#include <stm32f0xx.h>
#include "abstract-gpio-init.hpp"

#ifndef ABSTRACT_GPIO_H
#define ABSTRACT_GPIO_H

namespace stm32f072xb {
class AbstractGpio {
   public:
	AbstractGpio(GPIO_TypeDef* gpio, AbstractGpioInit gpioInit);
	GPIO_TypeDef* getGpio() { return _gpio; };
	uint8_t getPin() { return (uint8_t)_gpioInit.pin; }
	uint8_t getPullMode() { return (uint8_t)_gpioInit.pullMode; }
	~AbstractGpio();

   protected:
	void setupRegister();

   private:
	GPIO_TypeDef* _gpio;
	AbstractGpioInit _gpioInit;
};

}  // namespace stm32f072xb

#endif
