#include "gpio.hpp"
#include "input-gpio-init.hpp"

#ifndef INPUT_GPIO_H
#define INPUT_GPIO_H

namespace stm32f072xb {

template <Port T>
class InputGpio : public Gpio<T> {
   private:
   public:
	InputGpio(InputGpioInit gpioInit) : Gpio<T>(gpioInit) {
		CLEAR_BIT(this->getGpio()->MODER, 0x3UL << (this->getPin() * 2));
	}

	~InputGpio();

	FlagStatus readPin() {
		return READ_BIT(this->getGpio()->IDR, 1 << this->getPin()) ? FlagStatus::SET : FlagStatus::RESET;
	}

	bool isHigh() { return READ_BIT(this->getGpio()->IDR, 1 << this->getPin()); }

	bool isLow() { return !READ_BIT(this->getGpio()->IDR, 1 << this->getPin()); }
};
}  // namespace stm32f072xb
#endif
