#ifndef UART_GPIO_H
#define UART_GPIO_H

#include "alternate-gpio.hpp"
#include "uart-gpio-type.hpp"
#include "uart-register.hpp"

namespace stm32f072xb {
template <UartRegister T, UartGpioType V, Port U>
class UartGpio : public AlternateGpio<U> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART1, UartGpioType::TX, Port::A> : public AlternateGpio<Port::A> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART1, UartGpioType::RX, Port::A> : public AlternateGpio<Port::A> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART1, UartGpioType::TX, Port::B> : public AlternateGpio<Port::B> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART1, UartGpioType::RX, Port::B> : public AlternateGpio<Port::B> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART2, UartGpioType::TX, Port::A> : public AlternateGpio<Port::A> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART2, UartGpioType::RX, Port::A> : public AlternateGpio<Port::A> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART2, UartGpioType::TX, Port::D> : public AlternateGpio<Port::D> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART2, UartGpioType::RX, Port::D> : public AlternateGpio<Port::D> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART3, UartGpioType::TX, Port::B> : public AlternateGpio<Port::B> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART3, UartGpioType::RX, Port::B> : public AlternateGpio<Port::B> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART3, UartGpioType::TX, Port::C> : public AlternateGpio<Port::C> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART3, UartGpioType::RX, Port::C> : public AlternateGpio<Port::C> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART3, UartGpioType::TX, Port::D> : public AlternateGpio<Port::D> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART3, UartGpioType::RX, Port::D> : public AlternateGpio<Port::D> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART4, UartGpioType::TX, Port::A> : public AlternateGpio<Port::A> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART4, UartGpioType::RX, Port::A> : public AlternateGpio<Port::A> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART4, UartGpioType::TX, Port::C> : public AlternateGpio<Port::C> {
   private:
   public:
	UartGpio();
};

template <>
class UartGpio<UartRegister::UART4, UartGpioType::RX, Port::C> : public AlternateGpio<Port::C> {
   private:
   public:
	UartGpio();
};

}  // namespace stm32f072xb
#endif
