#ifndef ABSTRACT_UART_H
#define ABSTRACT_UART_H

#include <stm32f0xx.h>
#include "abstract-uart-init.hpp"

namespace stm32f072xb {
class AbstractUart {
   public:
	AbstractUart(USART_TypeDef* uart, AbstractUartInit uartInit);
	USART_TypeDef* getUart() { return _uart; };

	char readWord();
	void writeWord(uint16_t word);

	~AbstractUart();

   protected:
	void setupRegister();

   private:
	void setWordLength(WordLength wordLength);
	void setStopBits(StopBits stopBits);
	void setBaudRate(uint32_t baudRate);

	void enableUart();
	void enableTransmitter();
	void enableReception();

	USART_TypeDef* _uart;
	AbstractUartInit _uartInit;
};

}  // namespace stm32f072xb

#endif
